<?php
declare(strict_types=1);

namespace Drupal\maplibre_canvas_block\Plugin\Block;

use Drupal\Core\Block\BlockBase;
use Drupal\Core\Form\FormStateInterface;
use Drupal\maplibre_gl\Controller\MaplibreGlController;

/**
 * Provides a maplibre canvas block block.
 *
 * @Block(
 *   id = "maplibre_canvas_block",
 *   admin_label = @Translation("maplibre canvas block"),
 *   category = @Translation("Custom"),
 * )
 */
final class MaplibreCanvasBlockBlock extends BlockBase {

  /**
   * {@inheritdoc}
   */
  public function defaultConfiguration(): array {
    return [
      //'example' => $this->t('Hello world!'),
    ];
  }

  /**
   * {@inheritdoc}
   */
  public function blockForm($form, FormStateInterface $form_state): array {
    /*$form['example'] = [
      '#type' => 'textarea',
      '#title' => $this->t('Example'),
      '#default_value' => '',//$this->configuration['example'],
    ];*/
    return $form;
  }

  /**
   * {@inheritdoc}
   */
  public function blockSubmit($form, FormStateInterface $form_state): void {
    //$this->configuration['example'] = $form_state->getValue('example');
  }

  /**
   * {@inheritdoc}
   */
  public function build(): array {
    $build['map'] = MaplibreGlController::renderMap('maplibre_canvas_block');
    $build['map']['#attached']['drupalSettings']['maplibreCanvasBlock'] = [
      'layersdiv' => 'views-live-geojson'
    ];
    $build['map']['#attached']['library'][] = 'maplibre_canvas_block/layer_fetch';

    /*
    $build['content'] = [
      '#markup' => $this->t('It works!'),
    ];*/

    return $build;
  }

}
